000100 IDENTIFICATION DIVISION.                                         POS00163
000200 PROGRAM-ID.    CALCPK.                                           90/01/01
000300                                                                  90/01/01
000400 AUTHOR.        PIETER HINTJENS.                                  90/01/01
000500 DATE-WRITTEN.  89/06/05                                          90/01/01
000600     -REVISED:  99/04/10.                                         99/04/10
000700                                                                  90/01/01
000800 ENVIRONMENT DIVISION.                                            90/01/01
000900                                                                  90/01/01
001000 CONFIGURATION SECTION.                                           90/01/01
001100 SOURCE-COMPUTER. PORTABLE.                                       90/01/01
001200 OBJECT-COMPUTER. PORTABLE.                                       90/01/01
001300                                                                  90/01/01
001400 DATA DIVISION.                                                   90/01/01
001500                                                                  90/01/01
001600 WORKING-STORAGE SECTION.                                         90/01/01
001700                                                                  90/01/01
001800 01  EXPRESSION-PRIORITIES.                                       90/01/01
001900     02  END-MARK-PRIORITY       PIC 9      VALUE 1.              90/01/01
002000     02  LEFT-PAR-PRIORITY       PIC 9      VALUE 2.              90/01/01
002100     02  RIGHT-PAR-PRIORITY      PIC 9      VALUE 3.              90/01/01
002200     02  OR-OP-PRIORITY          PIC 9      VALUE 4.              95/12/23
002300     02  AND-OP-PRIORITY         PIC 9      VALUE 5.              95/12/23
002400     02  RELATION-OP-PRIORITY    PIC 9      VALUE 6.              95/12/23
002500     02  TERM-OP-PRIORITY        PIC 9      VALUE 7.              95/12/23
002600     02  FACTOR-OP-PRIORITY      PIC 9      VALUE 8.              95/12/23
002700     02  POWER-OP-PRIORITY       PIC 9      VALUE 9.              95/12/23
002800     02  FUNCTION-PRIORITY       PIC 9      VALUE 9.              95/12/23
002900     02  LOWEST-OPR-PRIORITY     PIC 9      VALUE 4.              95/12/23
003000                                                                  90/01/01
003100 01  VARIOUS-CONSTANTS.                                           90/01/01
003200     02  WHOLE-PART-SIZE         PIC S9(3)  COMP VALUE  +9.       90/01/01
003300     02  FRACTION-SIZE           PIC S9(3)  COMP VALUE  +9.       90/01/01
003400     02  FUNCTION-SIZE           PIC S9(3)  COMP VALUE  +3.       90/01/01
003500                                                                  90/01/01
003600 01  VARIOUS-NUMBERS.                                             90/01/01
003700     02  INV-LOG-OF-E            PIC S9(9)V9(9)  COMP             90/01/01
003800                                            VALUE +2.302585093.   90/01/01
003900     02  HALF-OF-PI              PIC S9(9)V9(9)  COMP             90/01/01
004000                                            VALUE +1.570796327.   90/01/01
004100     02  ROUND-UP-VALUE          PIC S9(9)V9(9)  COMP             90/01/01
004200                                            VALUE +0.500000000.   90/01/01
004300                                                                  90/01/01
004400 01  VARIOUS-TOKENS.                                              90/01/01
004500     02  POWER-OP-TOKEN          PIC X      VALUE "P".            90/01/01
004600     02  FUNCTION-TOKEN          PIC X      VALUE "F".            90/01/01
004700     02  END-MARK-TOKEN          PIC X      VALUE ";".            95/12/23
004800                                                                  90/01/01
004900 01  BEGIN-DYNAMIC-STORAGE       PIC X(4)   VALUE "<ETK".         90/01/01
005000                                                                  90/01/01
005100 01  VARIOUS-INDICES.                                             90/01/01
005200     02  CHAR-NBR                PIC S9(3)  COMP.                 90/01/01
005300     02  DIGIT-NBR               PIC S9(3)  COMP.                 90/01/01
005400     02  EXPR-INDEX              PIC S9(3)  COMP.                 90/01/01
005500     02  PEEK-INDEX              PIC S9(3)  COMP.                 95/12/21
005600     02  TOKEN-POSITION          PIC S9(3)  COMP.                 90/01/01
005700                                                                  90/01/01
005800 01  VARIOUS-VALUES.                                              90/01/01
005900     02  THE-TOKEN               PIC X.                           90/01/01
006000     02  THE-TOKEN-VALUE         REDEFINES  THE-TOKEN             90/01/01
006100                                 PIC 9.                           90/01/01
006200     02  THE-PRIORITY            PIC 9.                           90/01/01
006300     02  THE-OPERATOR            PIC X.                           90/01/01
006400         88  BINARY-OPERATOR                VALUE IS "+" "-" "*"  90/01/01
006500                                                     "/" "%" "P"  96/02/26
006600                                                     "=" ">" "<"  95/12/23
006700                                                     "N" "G" "L"  95/12/23
006800                                                     "!" "&".     95/12/23
006900     02  THE-NAME.                                                90/01/01
007000         88  VALID-VARIABLE-NAME            VALUE "A" "B" "C"     90/01/01
007100                                                  "D" "E" "R".    99/04/10
007200         88  VALID-FUNCTION-NAME            VALUE "ABS" "NEG"     90/01/01
007300                                                  "LNE" "EXP"     90/01/01
007400                                                  "LOG" "POW"     90/01/01
007500                                                  "SIN" "ASN"     90/01/01
007600                                                  "COS" "ACS"     90/01/01
007700                                                  "TAN" "ATN"     90/01/01
007800                                                  "SQR" "RND".    90/01/01
007900         03  THE-NAME-CHAR       PIC X      OCCURS 3 TIMES.       90/01/01
008000                                                                  90/01/01
008100     02  CUR-CHAR                PIC X.                           90/01/01
008200         88  VALID-NAME-CHAR                VALUE "A" THRU "Z".   90/01/01
008300                                                                  90/01/01
008400     02  THE-NUMBER              PIC S9(9)V9(9)  COMP.            93/08/19
008500     02  THE-NUMBER-TO-COLLECT   PIC 9(9)V9(9).                   93/08/19
008600     02  FILLER                  REDEFINES  THE-NUMBER-TO-COLLECT.93/08/19
008700         03  NUMBER-WHOLE-PART   PIC 9(9).                        90/01/01
008800         03  NUMBER-FRACT-CHAR   PIC X      OCCURS 9 TIMES.       90/01/01
008900                                                                  90/01/01
009000     02  COLLECTING-NUMBER       PIC X.                           90/01/01
009100         88  COLLECTING-WHOLE-PART          VALUE "W".            90/01/01
009200         88  COLLECTING-FRACTION            VALUE "F".            90/01/01
009300         88  NUMBER-IS-COLLECTED            VALUE "D".            90/01/01
009400                                                                  90/01/01
009500 01  VARIOUS-OPERANDS.                                            90/01/01
009600     02  OPERAND-1               PIC S9(9)V9(9) COMP.             90/01/01
009700     02  OPERAND-2               PIC S9(9)V9(9) COMP.             90/01/01
009800     02  OPERAND-INTEGER         PIC S9(9)      COMP.             90/01/01
009900                                                                  90/01/01
010000 01  OPERAND-STACK.                                               90/01/01
010100     02  OPERAND-PTR             PIC S9(3)  COMP.                 90/01/01
010200     02  OPERAND-MAX-PTR         PIC S9(3)  COMP VALUE +20.       90/01/01
010300     02  FILLER                             OCCURS 20 TIMES.      90/01/01
010400         03  STACK-OPERAND       PIC S9(9)V9(9) COMP.             90/01/01
010500                                                                  90/01/01
010600 01  OPERATOR-STACK.                                              90/01/01
010700     02  OPERATOR-PTR            PIC S9(3)  COMP.                 90/01/01
010800     02  OPERATOR-MAX-PTR        PIC S9(3)  COMP VALUE +20.       90/01/01
010900     02  FILLER                             OCCURS 20 TIMES.      90/01/01
011000         03  STACK-OPERATOR      PIC X.                           90/01/01
011100         03  STACK-OP-NAME       PIC X(3).                        90/01/01
011200         03  STACK-PRIORITY      PIC 9.                           90/01/01
011300                                                                  90/01/01
011400 01  MATHPK-CONTROL.                                              90/01/01
011500     02  MATHPK-TASK-ID          PIC X(4).                        90/01/01
011600     02  MATHPK-OPERATION        PIC X(8).                        90/01/01
011700     02  MATHPK-FEEDBACK         PIC X.                           90/01/01
011800     02  MATHPK-RESULT           PIC S9(9)V9(9) COMP.             90/01/01
011900     02  MATHPK-ARGUMENT         PIC S9(9)V9(9) COMP.             90/01/01
012000     02  MATHPK-AUXILLIARY       PIC S9(9)V9(9) COMP.             90/01/01
012100                                                                  90/01/01
012200 01  EXPRESSION-HANDLING.                                         95/12/23
012300     02  EXPR-STATE              PIC S9(3)  COMP.                 95/12/23
012400     02  INPUT-SIZE              PIC S9(3)  COMP VALUE +80.       95/12/23
012500     02  EXPR-SIZE               PIC S9(3)  COMP VALUE +81.       95/12/23
012600     02  THE-EXPRESSION.                                          95/12/23
012700         03  EXPR-CHAR           PIC X      OCCURS 81 TIMES.      95/12/23
012800                                                                  95/12/23
012900 01  PARAMETER-LIST.                                              90/01/01
013000     02  CALCPK-POINT-CHAR       PIC X.                           90/01/01
013100     02  CALCPK-ERROR-RETURN.                                     90/01/01
013200         03  CALCPK-ERROR-CODE   PIC X(2).                        90/01/01
013300         03  CALCPK-ERROR-MESG   PIC X(30).                       90/01/01
013400     02  CALCPK-ERROR-POSN       PIC 9(2).                        90/01/01
013500     02  CALCPK-EXPRESSION       PIC X(80).                       95/12/23
013600     02  CALCPK-RESULT           PIC S9(9)V9(9).                  90/01/01
013700     02  CALCPK-VARIABLE         PIC S9(9)V9(9) OCCURS 5 TIMES.   90/01/01
013800                                                                  90/01/01
013900*DIALOG MANAGER.                                                  90/01/01
014000 COPY CALCPKD.                                                    90/01/01
042300                                                                  90/01/01
042400******************    INITIALIZE THE PROGRAM    ******************90/01/01
042500                                                                  90/01/01
042600 INITIALIZE-THE-PROGRAM.                                          90/01/01
042700     MOVE PROGRAM-LINKAGE TO PARAMETER-LIST                       90/01/01
042800     MOVE SESSION-TASK-ID TO MATHPK-TASK-ID                       90/01/01
042900     MOVE      SPACE      TO PROGRAM-FEEDBACK                     90/01/01
043000                                                                  90/01/01
043100     IF PROGRAM-OPERATION = "C"                                   90/01/01
043200         PERFORM SET-OK                                           90/01/01
043300         PERFORM INITIALIZE-THE-PARSER                            90/01/01
043400     ELSE                                                         90/01/01
043500         PERFORM SET-ERROR                                        90/01/01
043600         MOVE "OPERATION" TO PROGRAM-FEEDBACK                     90/01/01
043700     .                                                            90/01/01
043800                                                                  90/01/01
043900 SET-OK.                                                          90/01/01
044000     MOVE OK-EVENT TO THE-NEXT-EVENT, EXPR-STATE                  95/12/23
044100     .                                                            90/01/01
044200                                                                  90/01/01
044300 INITIALIZE-THE-PARSER.                                           90/01/01
044400     MOVE      SPACES       TO CALCPK-ERROR-RETURN                90/01/01
044500     MOVE       ZERO        TO CALCPK-ERROR-POSN                  99/04/10
044600                                                                  95/12/23
044700     MOVE CALCPK-EXPRESSION TO THE-EXPRESSION                     95/12/23
044800     MOVE  END-MARK-TOKEN   TO EXPR-CHAR (81)                     95/12/23
044900     MOVE        1          TO EXPR-INDEX                         90/01/01
045000                                                                  95/12/23
045100     MOVE        1          TO OPERATOR-PTR                       90/01/01
045200     MOVE       ZERO        TO OPERAND-PTR                        90/01/01
045300     MOVE       ZERO        TO STACK-OPERAND  (1)                 95/12/23
045400     MOVE END-MARK-PRIORITY TO STACK-PRIORITY (1)                 95/12/23
045500     MOVE  END-MARK-TOKEN   TO STACK-OPERATOR (1)                 95/12/23
045600     .                                                            90/01/01
045700                                                                  90/01/01
045800 SET-ERROR.                                                       90/01/01
045900     MOVE ERROR-EVENT TO THE-NEXT-EVENT                           95/12/23
046000     .                                                            90/01/01
046100                                                                  90/01/01
046200**********************    GET NEXT TOKEN    **********************90/01/01
046300                                                                  90/01/01
046400 GET-NEXT-TOKEN.                                                  90/01/01
046500     PERFORM SKIP-SPACES                                          90/01/01
046600       VARYING EXPR-INDEX FROM EXPR-INDEX BY 1                    90/01/01
046700         UNTIL EXPR-CHAR (EXPR-INDEX) > SPACE                     90/01/01
046800                                                                  90/01/01
046900     MOVE EXPR-CHAR (EXPR-INDEX) TO THE-TOKEN                     90/01/01
047000     MOVE EXPR-INDEX             TO TOKEN-POSITION                90/01/01
047100     MOVE OTHER-EVENT            TO THE-NEXT-EVENT                90/01/01
047200                                                                  90/01/01
047300     IF THE-TOKEN = "+" OR "-"                                    90/01/01
047400         IF EXPR-STATE = OPERAND-EVENT                            95/12/23
047500            PERFORM HAVE-TERM-OP                                  95/12/23
047600         ELSE                                                     95/12/23
047700            PERFORM HAVE-UNARY-SIGN                               95/12/23
047800     ELSE                                                         90/01/01
047900     IF THE-TOKEN = "/" OR "%"                                    96/02/26
048000         PERFORM HAVE-FACTOR-OP                                   90/01/01
048100     ELSE                                                         90/01/01
048200     IF THE-TOKEN = "*"                                           90/01/01
048300         PERFORM MAY-HAVE-POWER-OP                                90/01/01
048400     ELSE                                                         90/01/01
048500     IF THE-TOKEN = ">" OR "<" OR "="                             95/12/23
048600         PERFORM HAVE-RELATION-OP                                 95/12/23
048700     ELSE                                                         95/12/23
048800     IF THE-TOKEN = "!"                                           95/12/23
048900         PERFORM HAVE-LOGICAL-OR-OP                               95/12/23
049000     ELSE                                                         95/12/23
049100     IF THE-TOKEN = "&"                                           95/12/23
049200         PERFORM HAVE-LOGICAL-AND-OP                              95/12/23
049300     ELSE                                                         95/12/23
049400     IF THE-TOKEN = "("                                           90/01/01
049500         PERFORM HAVE-LEFT-PAR                                    90/01/01
049600     ELSE                                                         90/01/01
049700     IF THE-TOKEN = ")"                                           90/01/01
049800         PERFORM HAVE-RIGHT-PAR                                   90/01/01
049900     ELSE                                                         90/01/01
050000     IF THE-TOKEN IS NUMERIC                                      90/01/01
050100         PERFORM HAVE-NUMBER                                      90/01/01
050200     ELSE                                                         90/01/01
050300     IF THE-TOKEN IS ALPHABETIC                                   90/01/01
050400         PERFORM HAVE-NAMED-ITEM                                  90/01/01
050500     ELSE                                                         90/01/01
050600     IF THE-TOKEN = END-MARK-TOKEN                                90/01/01
050700         PERFORM HAVE-END-MARK                                    90/01/01
050800     ELSE                                                         90/01/01
050900         PERFORM SIGNAL-INVALID-CHAR                              90/01/01
051000     .                                                            90/01/01
051100                                                                  90/01/01
051200 SKIP-SPACES.                                                     90/01/01
051300     EXIT                                                         90/01/01
051400     .                                                            90/01/01
051500                                                                  90/01/01
051600 HAVE-TERM-OP.                                                    90/01/01
051700     MOVE TERM-OP-PRIORITY TO THE-PRIORITY                        90/01/01
051800     PERFORM SET-OPERATOR-EVENT                                   95/12/23
051900     ADD 1 TO EXPR-INDEX                                          90/01/01
052000     .                                                            90/01/01
052100                                                                  90/01/01
052200 SET-OPERATOR-EVENT.                                              95/12/23
052300     MOVE OPERATOR-EVENT TO THE-NEXT-EVENT, EXPR-STATE            95/12/23
052400     .                                                            95/12/23
052500                                                                  95/12/23
052600 HAVE-UNARY-SIGN.                                                 95/12/21
052700     MOVE EXPR-CHAR (EXPR-INDEX) TO CUR-CHAR                      95/12/21
052800     IF CUR-CHAR = "-"                                            95/12/21
052900         MOVE "NEG" TO THE-NAME                                   95/12/21
053000         PERFORM HAVE-FUNCTION                                    95/12/21
053100     ELSE                                                         95/12/21
053200         MOVE IGNORE-EVENT TO THE-NEXT-EVENT                      95/12/21
053300     .                                                            95/12/21
053400     ADD 1 TO EXPR-INDEX                                          95/12/21
053500     .                                                            95/12/21
053600                                                                  95/12/21
053700 HAVE-FACTOR-OP.                                                  90/01/01
053800     MOVE FACTOR-OP-PRIORITY TO THE-PRIORITY                      90/01/01
053900     PERFORM SET-OPERATOR-EVENT                                   95/12/23
054000     ADD 1 TO EXPR-INDEX                                          90/01/01
054100     .                                                            90/01/01
054200                                                                  90/01/01
054300 MAY-HAVE-POWER-OP.                                               90/01/01
054400     PERFORM HAVE-FACTOR-OP                                       90/01/01
054500     IF EXPR-CHAR (EXPR-INDEX) = "*"                              90/01/01
054600         MOVE POWER-OP-TOKEN    TO THE-TOKEN                      90/01/01
054700         MOVE POWER-OP-PRIORITY TO THE-PRIORITY                   90/01/01
054800         PERFORM SET-OPERATOR-EVENT                               95/12/23
054900         ADD 1 TO EXPR-INDEX                                      90/01/01
055000     .                                                            90/01/01
055100                                                                  90/01/01
055200 HAVE-RELATION-OP.                                                95/12/23
055300     COMPUTE PEEK-INDEX = EXPR-INDEX + 1                          95/12/23
055400     MOVE EXPR-CHAR (PEEK-INDEX) TO CUR-CHAR                      95/12/23
055500     IF THE-TOKEN = "<" AND CUR-CHAR = ">"                        95/12/23
055600         ADD 1 TO EXPR-INDEX                                      95/12/23
055700         MOVE "N" TO THE-TOKEN                                    95/12/23
055800     ELSE                                                         95/12/23
055900     IF THE-TOKEN = "<" AND CUR-CHAR = "="                        95/12/23
056000         ADD 1 TO EXPR-INDEX                                      95/12/23
056100         MOVE "L" TO THE-TOKEN                                    95/12/23
056200     ELSE                                                         95/12/23
056300     IF THE-TOKEN = ">" AND CUR-CHAR = "="                        95/12/23
056400         ADD 1 TO EXPR-INDEX                                      95/12/23
056500         MOVE "G" TO THE-TOKEN                                    95/12/23
056600     .                                                            95/12/23
056700     MOVE RELATION-OP-PRIORITY TO THE-PRIORITY                    95/12/23
056800     PERFORM SET-OPERATOR-EVENT                                   95/12/23
056900     ADD 1 TO EXPR-INDEX                                          95/12/23
057000     .                                                            95/12/23
057100                                                                  95/12/23
057200 HAVE-LOGICAL-OR-OP.                                              95/12/23
057300     MOVE OR-OP-PRIORITY TO THE-PRIORITY                          95/12/23
057400     PERFORM SET-OPERATOR-EVENT                                   95/12/23
057500     ADD 1 TO EXPR-INDEX                                          95/12/23
057600     .                                                            95/12/23
057700                                                                  95/12/23
057800 HAVE-LOGICAL-AND-OP.                                             95/12/23
057900     MOVE AND-OP-PRIORITY TO THE-PRIORITY                         95/12/23
058000     PERFORM SET-OPERATOR-EVENT                                   95/12/23
058100     ADD 1 TO EXPR-INDEX                                          95/12/23
058200     .                                                            95/12/23
058300                                                                  95/12/23
058400 HAVE-LEFT-PAR.                                                   90/01/01
058500     MOVE LEFT-PAR-PRIORITY TO THE-PRIORITY                       90/01/01
058600     MOVE LEFT-PAR-EVENT    TO THE-NEXT-EVENT, EXPR-STATE         95/12/23
058700     ADD 1 TO EXPR-INDEX                                          90/01/01
058800     .                                                            90/01/01
058900                                                                  90/01/01
059000 HAVE-RIGHT-PAR.                                                  90/01/01
059100     MOVE RIGHT-PAR-PRIORITY TO THE-PRIORITY                      90/01/01
059200     MOVE RIGHT-PAR-EVENT    TO THE-NEXT-EVENT                    95/12/23
059300     MOVE OPERAND-EVENT      TO EXPR-STATE                        95/12/23
059400     ADD 1 TO EXPR-INDEX                                          90/01/01
059500     .                                                            90/01/01
059600                                                                  90/01/01
059700 HAVE-NUMBER.                                                     90/01/01
059800     PERFORM SET-OPERAND-EVENT                                    95/12/23
059900     MOVE ZERO TO THE-NUMBER-TO-COLLECT, DIGIT-NBR                95/12/23
060000     MOVE "WHOLE PART" TO COLLECTING-NUMBER                       95/12/23
060100     PERFORM COLLECT-THE-NUMBER                                   90/01/01
060200       UNTIL NUMBER-IS-COLLECTED                                  90/01/01
060300                                                                  93/08/19
060400     MOVE THE-NUMBER-TO-COLLECT TO THE-NUMBER                     93/08/19
060500     .                                                            90/01/01
060600                                                                  90/01/01
060700 SET-OPERAND-EVENT.                                               95/12/23
060800     MOVE OPERAND-EVENT TO THE-NEXT-EVENT, EXPR-STATE             95/12/23
060900     .                                                            95/12/23
061000                                                                  95/12/23
061100 COLLECT-THE-NUMBER.                                              90/01/01
061200     IF COLLECTING-WHOLE-PART                                     90/01/01
061300         PERFORM GET-TOKEN-IN-WHOLE-PART                          90/01/01
061400     ELSE                                                         90/01/01
061500     IF COLLECTING-FRACTION                                       90/01/01
061600         PERFORM GET-TOKEN-IN-FRACTION                            90/01/01
061700     .                                                            90/01/01
061800     MOVE EXPR-CHAR (EXPR-INDEX) TO THE-TOKEN                     90/01/01
061900     .                                                            90/01/01
062000                                                                  90/01/01
062100 GET-TOKEN-IN-WHOLE-PART.                                         90/01/01
062200     IF THE-TOKEN IS NUMERIC                                      90/01/01
062300         ADD 1 TO DIGIT-NBR                                       90/01/01
062400         PERFORM PICK-UP-WHOLE-PART-DIGIT                         90/01/01
062500     ELSE                                                         90/01/01
062600     IF THE-TOKEN = CALCPK-POINT-CHAR                             90/01/01
062700         MOVE "FRACTION" TO COLLECTING-NUMBER                     90/01/01
062800         MOVE    ZERO    TO DIGIT-NBR                             90/01/01
062900         ADD 1 TO EXPR-INDEX                                      90/01/01
063000     ELSE                                                         90/01/01
063100         MOVE "DONE" TO COLLECTING-NUMBER                         90/01/01
063200     .                                                            90/01/01
063300                                                                  90/01/01
063400 PICK-UP-WHOLE-PART-DIGIT.                                        90/01/01
063500     IF DIGIT-NBR > WHOLE-PART-SIZE                               90/01/01
063600         MOVE "WFWHOLE PART OF NUMBER TOO LARGE"                  95/12/23
063700                     TO CALCPK-ERROR-RETURN                       90/01/01
063800         MOVE "DONE" TO COLLECTING-NUMBER                         90/01/01
063900         PERFORM SIGNAL-OVERFLOW-ERROR                            90/01/01
064000     ELSE                                                         90/01/01
064100         COMPUTE NUMBER-WHOLE-PART                                90/01/01
064200               = NUMBER-WHOLE-PART * 10 + THE-TOKEN-VALUE         90/01/01
064300         ADD 1 TO EXPR-INDEX                                      90/01/01
064400     .                                                            90/01/01
064500                                                                  90/01/01
064600 SIGNAL-OVERFLOW-ERROR.                                           90/01/01
064700     MOVE "FULL"     TO PROGRAM-FEEDBACK                          90/01/01
064800     MOVE EXPR-INDEX TO CALCPK-ERROR-POSN                         90/01/01
064900     PERFORM RAISE-EXCEPTION                                      90/01/01
065000     .                                                            90/01/01
065100                                                                  90/01/01
065200 RAISE-EXCEPTION.                                                 90/01/01
065300     MOVE      "YES"      TO EXCEPTION-RAISED                     90/01/01
065400     MOVE EXCEPTION-EVENT TO THE-EXCEPTION-EVENT                  90/01/01
065500     .                                                            90/01/01
065600                                                                  90/01/01
065700 GET-TOKEN-IN-FRACTION.                                           90/01/01
065800     IF THE-TOKEN IS NUMERIC                                      90/01/01
065900         ADD 1 TO DIGIT-NBR                                       90/01/01
066000         PERFORM PICK-UP-FRACTION-DIGIT                           90/01/01
066100     ELSE                                                         90/01/01
066200         MOVE "DONE" TO COLLECTING-NUMBER                         90/01/01
066300     .                                                            90/01/01
066400                                                                  90/01/01
066500 PICK-UP-FRACTION-DIGIT.                                          90/01/01
066600     IF DIGIT-NBR > FRACTION-SIZE                                 90/01/01
066700         MOVE "FFFRACTION OF NUMBER TOO LARGE"                    95/12/23
066800                     TO CALCPK-ERROR-RETURN                       90/01/01
066900         MOVE "DONE" TO COLLECTING-NUMBER                         90/01/01
067000         PERFORM SIGNAL-OVERFLOW-ERROR                            90/01/01
067100     ELSE                                                         90/01/01
067200         MOVE THE-TOKEN TO NUMBER-FRACT-CHAR (DIGIT-NBR)          90/01/01
067300         ADD 1 TO EXPR-INDEX                                      90/01/01
067400     .                                                            90/01/01
067500                                                                  90/01/01
067600 HAVE-NAMED-ITEM.                                                 90/01/01
067700     MOVE SPACES TO THE-NAME                                      90/01/01
067800     PERFORM PICK-UP-THE-NAME-CHAR                                90/01/01
067900       VARYING CHAR-NBR FROM 1 BY 1                               90/01/01
068000         UNTIL CHAR-NBR > FUNCTION-SIZE                           90/01/01
068100                                                                  90/01/01
068200     IF VALID-VARIABLE-NAME                                       90/01/01
068300         PERFORM HAVE-VARIABLE                                    90/01/01
068400     ELSE                                                         90/01/01
068500     IF VALID-FUNCTION-NAME                                       90/01/01
068600         PERFORM HAVE-FUNCTION                                    90/01/01
068700     ELSE                                                         90/01/01
068800         PERFORM SIGNAL-VARIABLE-EXPECTED                         95/12/21
068900     .                                                            95/12/21
069000                                                                  95/12/21
069100 SIGNAL-VARIABLE-EXPECTED.                                        95/12/21
069200     MOVE "INNOT FUNCTION OR VARIABLE NAME"                       95/12/23
069300       TO CALCPK-ERROR-RETURN                                     95/12/21
069400     PERFORM SIGNAL-SYNTAX-ERROR                                  95/12/21
069500     .                                                            90/01/01
069600                                                                  90/01/01
069700 PICK-UP-THE-NAME-CHAR.                                           90/01/01
069800     IF EXPR-INDEX < EXPR-SIZE                                    90/01/01
069900         MOVE EXPR-CHAR (EXPR-INDEX) TO CUR-CHAR                  90/01/01
070000         IF VALID-NAME-CHAR                                       90/01/01
070100             MOVE CUR-CHAR TO THE-NAME-CHAR (CHAR-NBR)            90/01/01
070200             ADD 1 TO EXPR-INDEX                                  90/01/01
070300     .                                                            90/01/01
070400                                                                  90/01/01
070500 HAVE-VARIABLE.                                                   90/01/01
070600     PERFORM SET-OPERAND-EVENT                                    95/12/23
070700     IF THE-NAME = "A"                                            90/01/01
070800         MOVE CALCPK-VARIABLE (1) TO THE-NUMBER                   90/01/01
070900     ELSE                                                         90/01/01
071000     IF THE-NAME = "B"                                            90/01/01
071100         MOVE CALCPK-VARIABLE (2) TO THE-NUMBER                   90/01/01
071200     ELSE                                                         90/01/01
071300     IF THE-NAME = "C"                                            90/01/01
071400         MOVE CALCPK-VARIABLE (3) TO THE-NUMBER                   90/01/01
071500     ELSE                                                         90/01/01
071600     IF THE-NAME = "D"                                            90/01/01
071700         MOVE CALCPK-VARIABLE (4) TO THE-NUMBER                   90/01/01
071800     ELSE                                                         90/01/01
071900     IF THE-NAME = "E"                                            90/01/01
072000         MOVE CALCPK-VARIABLE (5) TO THE-NUMBER                   90/01/01
072100     ELSE                                                         99/04/10
072200     IF THE-NAME = "R"                                            99/04/10
072300         MOVE CALCPK-RESULT       TO THE-NUMBER                   99/04/10
072400     .                                                            90/01/01
072500                                                                  90/01/01
072600 HAVE-FUNCTION.                                                   90/01/01
072700     MOVE FUNCTION-TOKEN    TO THE-TOKEN                          90/01/01
072800     MOVE FUNCTION-PRIORITY TO THE-PRIORITY                       90/01/01
072900     MOVE FUNCTION-EVENT    TO THE-NEXT-EVENT, EXPR-STATE         95/12/23
073000     .                                                            90/01/01
073100                                                                  90/01/01
073200 HAVE-END-MARK.                                                   90/01/01
073300     IF EXPR-INDEX < EXPR-SIZE                                    90/01/01
073400         PERFORM SIGNAL-INVALID-CHAR                              90/01/01
073500     ELSE                                                         90/01/01
073600         MOVE END-MARK-PRIORITY TO THE-PRIORITY                   90/01/01
073700         MOVE END-MARK-EVENT    TO THE-NEXT-EVENT                 90/01/01
073800     .                                                            90/01/01
073900                                                                  90/01/01
074000 SIGNAL-INVALID-CHAR.                                             90/01/01
074100     MOVE "ICINVALID CHARACTER" TO CALCPK-ERROR-RETURN            95/12/23
074200     PERFORM SIGNAL-SYNTAX-ERROR                                  90/01/01
074300     .                                                            90/01/01
074400                                                                  90/01/01
074500 SIGNAL-SYNTAX-ERROR.                                             90/01/01
074600     MOVE "SYNTAX ERROR" TO PROGRAM-FEEDBACK                      90/01/01
074700     MOVE TOKEN-POSITION TO CALCPK-ERROR-POSN                     90/01/01
074800     PERFORM RAISE-EXCEPTION                                      90/01/01
074900     .                                                            90/01/01
075000                                                                  90/01/01
075100********************    STACK THE OPERAND    *********************90/01/01
075200                                                                  90/01/01
075300 STACK-THE-OPERAND.                                               90/01/01
075400     IF OPERAND-PTR < OPERAND-MAX-PTR                             90/01/01
075500         ADD 1 TO OPERAND-PTR                                     90/01/01
075600         MOVE THE-NUMBER TO STACK-OPERAND (OPERAND-PTR)           90/01/01
075700     ELSE                                                         90/01/01
075800         MOVE "DFOPERAND STACK FULL" TO CALCPK-ERROR-RETURN       95/12/23
075900         PERFORM SIGNAL-OVERFLOW-ERROR                            90/01/01
076000     .                                                            90/01/01
076100                                                                  90/01/01
076200*******************    STACK THE OPERATOR   **********************90/01/01
076300                                                                  90/01/01
076400 STACK-THE-OPERATOR.                                              90/01/01
076500     IF OPERATOR-PTR < OPERATOR-MAX-PTR                           90/01/01
076600         ADD 1 TO OPERATOR-PTR                                    90/01/01
076700         MOVE THE-TOKEN    TO STACK-OPERATOR (OPERATOR-PTR)       90/01/01
076800         MOVE THE-NAME     TO STACK-OP-NAME  (OPERATOR-PTR)       90/01/01
076900         MOVE THE-PRIORITY TO STACK-PRIORITY (OPERATOR-PTR)       90/01/01
077000     ELSE                                                         90/01/01
077100         MOVE "RFOPERATOR STACK FULL" TO CALCPK-ERROR-RETURN      95/12/23
077200         PERFORM SIGNAL-OVERFLOW-ERROR                            90/01/01
077300     .                                                            90/01/01
077400                                                                  90/01/01
077500*******************    UNSTACK GE OPERATORS    *******************90/01/01
077600                                                                  90/01/01
077700 UNSTACK-GE-OPERATORS.                                            90/01/01
077800     PERFORM UNSTACK-OPERATOR                                     90/01/01
077900       UNTIL STACK-PRIORITY (OPERATOR-PTR) < THE-PRIORITY         90/01/01
078000     .                                                            90/01/01
078100                                                                  90/01/01
078200 UNSTACK-OPERATOR.                                                90/01/01
078300     MOVE STACK-OPERATOR (OPERATOR-PTR) TO THE-OPERATOR           90/01/01
078400     MOVE STACK-OP-NAME  (OPERATOR-PTR) TO THE-NAME               90/01/01
078500     SUBTRACT 1 FROM OPERATOR-PTR                                 90/01/01
078600     PERFORM EXECUTE-THE-OPERATION                                90/01/01
078700     .                                                            90/01/01
078800                                                                  90/01/01
078900 EXECUTE-THE-OPERATION.                                           90/01/01
079000     MOVE STACK-OPERAND (OPERAND-PTR) TO OPERAND-1                90/01/01
079100     IF BINARY-OPERATOR                                           90/01/01
079200         PERFORM BINARY-OPERATION                                 90/01/01
079300     ELSE                                                         90/01/01
079400     IF THE-OPERATOR = FUNCTION-TOKEN                             90/01/01
079500         PERFORM FUNCTION-OPERATION                               90/01/01
079600     ELSE                                                         90/01/01
079700     IF THE-OPERATOR = END-MARK-TOKEN                             90/01/01
079800         PERFORM END-OPERATION                                    90/01/01
079900     .                                                            90/01/01
080000     MOVE OPERAND-1 TO STACK-OPERAND (OPERAND-PTR)                90/01/01
080100     .                                                            90/01/01
080200                                                                  90/01/01
080300 BINARY-OPERATION.                                                90/01/01
080400     SUBTRACT 1 FROM OPERAND-PTR                                  90/01/01
080500     MOVE OPERAND-1                   TO OPERAND-2                90/01/01
080600     MOVE STACK-OPERAND (OPERAND-PTR) TO OPERAND-1                90/01/01
080700     IF THE-OPERATOR = "+"                                        90/01/01
080800         COMPUTE OPERAND-1 = OPERAND-1 + OPERAND-2                90/01/01
080900     ELSE                                                         90/01/01
081000     IF THE-OPERATOR = "-"                                        90/01/01
081100         COMPUTE OPERAND-1 = OPERAND-1 - OPERAND-2                90/01/01
081200     ELSE                                                         90/01/01
081300     IF THE-OPERATOR = "*"                                        90/01/01
081400         COMPUTE OPERAND-1 = OPERAND-1 * OPERAND-2                90/01/01
081500     ELSE                                                         90/01/01
081600     IF THE-OPERATOR = "/"                                        90/01/01
081700         IF OPERAND-2 = ZERO                                      90/01/01
081800             COMPUTE OPERAND-1 = ZERO                             90/01/01
081900         ELSE                                                     90/01/01
082000             COMPUTE OPERAND-1 = OPERAND-1 / OPERAND-2            90/01/01
082100     ELSE                                                         90/01/01
082200     IF THE-OPERATOR = "%"                                        96/02/26
082300         IF OPERAND-2 = ZERO                                      96/02/26
082400             COMPUTE OPERAND-1 = ZERO                             96/02/26
082500         ELSE                                                     96/02/26
082600             COMPUTE OPERAND-INTEGER = OPERAND-1 / OPERAND-2      96/02/26
082700             COMPUTE OPERAND-1       = OPERAND-1 - OPERAND-2      96/02/26
082800                                         * OPERAND-INTEGER        96/02/26
082900     ELSE                                                         96/02/26
083000     IF THE-OPERATOR = POWER-OP-TOKEN                             90/01/01
083100         PERFORM POWER-OPERATION                                  90/01/01
083200     ELSE                                                         95/12/23
083300     IF THE-OPERATOR = "="                                        95/12/23
083400         IF OPERAND-1 = OPERAND-2                                 95/12/23
083500             MOVE 1 TO OPERAND-1                                  95/12/23
083600         ELSE                                                     95/12/23
083700             MOVE 0 TO OPERAND-1                                  95/12/23
083800     ELSE                                                         95/12/23
083900     IF THE-OPERATOR = ">"                                        95/12/23
084000         IF OPERAND-1 > OPERAND-2                                 95/12/23
084100             MOVE 1 TO OPERAND-1                                  95/12/23
084200         ELSE                                                     95/12/23
084300             MOVE 0 TO OPERAND-1                                  95/12/23
084400     ELSE                                                         95/12/23
084500     IF THE-OPERATOR = "<"                                        95/12/23
084600         IF OPERAND-1 < OPERAND-2                                 95/12/23
084700             MOVE 1 TO OPERAND-1                                  95/12/23
084800         ELSE                                                     95/12/23
084900             MOVE 0 TO OPERAND-1                                  95/12/23
085000     ELSE                                                         95/12/23
085100     IF THE-OPERATOR = "N"                                        95/12/23
085200         IF OPERAND-1 NOT = OPERAND-2                             95/12/23
085300             MOVE 1 TO OPERAND-1                                  95/12/23
085400         ELSE                                                     95/12/23
085500             MOVE 0 TO OPERAND-1                                  95/12/23
085600     ELSE                                                         95/12/23
085700     IF THE-OPERATOR = "G"                                        95/12/23
085800         IF OPERAND-1 NOT < OPERAND-2                             95/12/23
085900             MOVE 1 TO OPERAND-1                                  95/12/23
086000         ELSE                                                     95/12/23
086100             MOVE 0 TO OPERAND-1                                  95/12/23
086200     ELSE                                                         95/12/23
086300     IF THE-OPERATOR = "L"                                        95/12/23
086400         IF OPERAND-1 NOT > OPERAND-2                             95/12/23
086500             MOVE 1 TO OPERAND-1                                  95/12/23
086600         ELSE                                                     95/12/23
086700             MOVE 0 TO OPERAND-1                                  95/12/23
086800     ELSE                                                         95/12/23
086900     IF THE-OPERATOR = "!"                                        95/12/23
087000         IF  OPERAND-1 = 1 OR 0                                   95/12/23
087100         AND OPERAND-2 = 1 OR 0                                   95/12/23
087200             IF OPERAND-1 = 1                                     95/12/23
087300             OR OPERAND-2 = 1                                     95/12/23
087400                 MOVE 1 TO OPERAND-1                              95/12/23
087500             ELSE                                                 95/12/23
087600                 MOVE 0 TO OPERAND-1                              95/12/23
087700         ELSE                                                     95/12/23
087800             PERFORM SIGNAL-NOT-LOGICAL-EXPRESSION                95/12/23
087900     ELSE                                                         95/12/23
088000     IF THE-OPERATOR = "&"                                        95/12/23
088100         IF  OPERAND-1 = 1 OR 0                                   95/12/23
088200         AND OPERAND-2 = 1 OR 0                                   95/12/23
088300             IF  OPERAND-1 = 1                                    95/12/23
088400             AND OPERAND-2 = 1                                    95/12/23
088500                 MOVE 1 TO OPERAND-1                              95/12/23
088600             ELSE                                                 95/12/23
088700                 MOVE 0 TO OPERAND-1                              95/12/23
088800         ELSE                                                     95/12/23
088900             PERFORM SIGNAL-NOT-LOGICAL-EXPRESSION                95/12/23
089000     .                                                            90/01/01
089100     MOVE OPERAND-1 TO STACK-OPERAND (OPERAND-PTR)                90/01/01
089200     .                                                            90/01/01
089300                                                                  90/01/01
089400 POWER-OPERATION.                                                 90/01/01
089500     MOVE  "POWER"  TO MATHPK-OPERATION                           90/01/01
089600     MOVE OPERAND-2 TO MATHPK-AUXILLIARY                          90/01/01
089700     PERFORM CALL-MATHPK                                          90/01/01
089800     .                                                            90/01/01
089900                                                                  90/01/01
090000 CALL-MATHPK.                                                     90/01/01
090100     MOVE OPERAND-1 TO MATHPK-ARGUMENT                            90/01/01
090200     CALL "MATHPK"                                                90/01/01
090300         USING MATHPK-CONTROL                                     90/01/01
090400                                                                  90/01/01
090500     IF MATHPK-FEEDBACK = SPACE                                   90/01/01
090600         MOVE MATHPK-RESULT TO OPERAND-1                          90/01/01
090700     ELSE                                                         90/01/01
090800         MOVE     ZERO      TO OPERAND-1                          90/01/01
090900         PERFORM SIGNAL-RANGE-ERROR                               95/12/23
091000     .                                                            90/01/01
091100                                                                  90/01/01
091200 FUNCTION-OPERATION.                                              90/01/01
091300     IF THE-NAME = "ABS"                                          90/01/01
091400         PERFORM UNARY-ABS-OPERATION                              90/01/01
091500     ELSE                                                         90/01/01
091600     IF THE-NAME = "NEG"                                          90/01/01
091700         PERFORM UNARY-NEG-OPERATION                              90/01/01
091800     ELSE                                                         90/01/01
091900     IF THE-NAME = "LNE"                                          90/01/01
092000         PERFORM UNARY-LNE-OPERATION                              90/01/01
092100     ELSE                                                         90/01/01
092200     IF THE-NAME = "EXP"                                          90/01/01
092300         PERFORM UNARY-EXP-OPERATION                              90/01/01
092400     ELSE                                                         90/01/01
092500     IF THE-NAME = "LOG"                                          90/01/01
092600         PERFORM UNARY-LOG-OPERATION                              90/01/01
092700     ELSE                                                         90/01/01
092800     IF THE-NAME = "POW"                                          90/01/01
092900         PERFORM UNARY-POW-OPERATION                              90/01/01
093000     ELSE                                                         90/01/01
093100     IF THE-NAME = "SIN"                                          90/01/01
093200         PERFORM UNARY-SIN-OPERATION                              90/01/01
093300     ELSE                                                         90/01/01
093400     IF THE-NAME = "ASN"                                          90/01/01
093500         PERFORM UNARY-ASN-OPERATION                              90/01/01
093600     ELSE                                                         90/01/01
093700     IF THE-NAME = "COS"                                          90/01/01
093800         PERFORM UNARY-COS-OPERATION                              90/01/01
093900     ELSE                                                         90/01/01
094000     IF THE-NAME = "ACS"                                          90/01/01
094100         PERFORM UNARY-ACS-OPERATION                              90/01/01
094200     ELSE                                                         90/01/01
094300     IF THE-NAME = "TAN"                                          90/01/01
094400         PERFORM UNARY-TAN-OPERATION                              90/01/01
094500     ELSE                                                         90/01/01
094600     IF THE-NAME = "ATN"                                          90/01/01
094700         PERFORM UNARY-ATN-OPERATION                              90/01/01
094800     ELSE                                                         90/01/01
094900     IF THE-NAME = "SQR"                                          90/01/01
095000          PERFORM UNARY-SQR-OPERATION                             90/01/01
095100     ELSE                                                         90/01/01
095200     IF THE-NAME = "RND"                                          90/01/01
095300         PERFORM UNARY-RND-OPERATION                              90/01/01
095400     .                                                            90/01/01
095500                                                                  90/01/01
095600 UNARY-ABS-OPERATION.                                             90/01/01
095700     IF OPERAND-1 < ZERO                                          90/01/01
095800         COMPUTE OPERAND-1 = ZERO - OPERAND-1                     90/01/01
095900     .                                                            90/01/01
096000                                                                  90/01/01
096100 UNARY-NEG-OPERATION.                                             90/01/01
096200     COMPUTE OPERAND-1 = ZERO - OPERAND-1                         90/01/01
096300     .                                                            90/01/01
096400                                                                  90/01/01
096500 UNARY-LNE-OPERATION.                                             90/01/01
096600     MOVE "LOG10" TO MATHPK-OPERATION                             90/01/01
096700     PERFORM CALL-MATHPK                                          90/01/01
096800     COMPUTE OPERAND-1 = OPERAND-1 * INV-LOG-OF-E                 90/01/01
096900     .                                                            90/01/01
097000                                                                  90/01/01
097100 UNARY-EXP-OPERATION.                                             90/01/01
097200     MOVE "EXP" TO MATHPK-OPERATION                               90/01/01
097300     PERFORM CALL-MATHPK                                          90/01/01
097400     .                                                            90/01/01
097500                                                                  90/01/01
097600 UNARY-LOG-OPERATION.                                             90/01/01
097700     MOVE "LOG10" TO MATHPK-OPERATION                             90/01/01
097800     PERFORM CALL-MATHPK                                          90/01/01
097900     .                                                            90/01/01
098000                                                                  90/01/01
098100 UNARY-POW-OPERATION.                                             90/01/01
098200     MOVE "ALOG10" TO MATHPK-OPERATION                            90/01/01
098300     PERFORM CALL-MATHPK                                          90/01/01
098400     .                                                            90/01/01
098500                                                                  90/01/01
098600 UNARY-SIN-OPERATION.                                             90/01/01
098700     MOVE "SIN" TO MATHPK-OPERATION                               90/01/01
098800     PERFORM CALL-MATHPK                                          90/01/01
098900     .                                                            90/01/01
099000                                                                  90/01/01
099100 UNARY-ASN-OPERATION.                                             90/01/01
099200     MOVE "ARCSIN" TO MATHPK-OPERATION                            90/01/01
099300     PERFORM CALL-MATHPK                                          90/01/01
099400     .                                                            90/01/01
099500                                                                  90/01/01
099600 UNARY-COS-OPERATION.                                             90/01/01
099700     MOVE "COS" TO MATHPK-OPERATION                               90/01/01
099800     PERFORM CALL-MATHPK                                          90/01/01
099900     .                                                            90/01/01
100000                                                                  90/01/01
100100 UNARY-ACS-OPERATION.                                             90/01/01
100200     MOVE "ARCSIN" TO MATHPK-OPERATION                            90/01/01
100300     PERFORM CALL-MATHPK                                          90/01/01
100400     COMPUTE OPERAND-1 = HALF-OF-PI - OPERAND-1                   90/01/01
100500     .                                                            90/01/01
100600                                                                  90/01/01
100700 UNARY-TAN-OPERATION.                                             90/01/01
100800     MOVE "COS" TO MATHPK-OPERATION                               90/01/01
100900     PERFORM CALL-MATHPK                                          90/01/01
101000     MOVE OPERAND-1                   TO OPERAND-2                90/01/01
101100     MOVE STACK-OPERAND (OPERAND-PTR) TO OPERAND-1                90/01/01
101200                                                                  90/01/01
101300     MOVE "SIN" TO MATHPK-OPERATION                               90/01/01
101400     PERFORM CALL-MATHPK                                          90/01/01
101500     COMPUTE OPERAND-1 = OPERAND-1 / OPERAND-2                    90/01/01
101600     .                                                            90/01/01
101700                                                                  90/01/01
101800 UNARY-ATN-OPERATION.                                             90/01/01
101900     MOVE "ARCTAN" TO MATHPK-OPERATION                            90/01/01
102000     PERFORM CALL-MATHPK                                          90/01/01
102100     .                                                            90/01/01
102200                                                                  90/01/01
102300 UNARY-SQR-OPERATION.                                             90/01/01
102400     MOVE "SQRT" TO MATHPK-OPERATION                              90/01/01
102500     PERFORM CALL-MATHPK                                          90/01/01
102600     .                                                            90/01/01
102700                                                                  90/01/01
102800 UNARY-RND-OPERATION.                                             90/01/01
102900     IF OPERAND-1 > ZERO                                          90/01/01
103000         COMPUTE OPERAND-1 = OPERAND-1 + ROUND-UP-VALUE           90/01/01
103100     ELSE                                                         90/01/01
103200         COMPUTE OPERAND-1 = OPERAND-1 - ROUND-UP-VALUE           90/01/01
103300     .                                                            90/01/01
103400     MOVE OPERAND-1       TO OPERAND-INTEGER                      90/01/01
103500     MOVE OPERAND-INTEGER TO OPERAND-1                            90/01/01
103600     .                                                            90/01/01
103700                                                                  90/01/01
103800 END-OPERATION.                                                   90/01/01
103900     IF OPERAND-PTR = 1                                           90/01/01
104000         MOVE OPERAND-1 TO CALCPK-RESULT                          90/01/01
104100     .                                                            90/01/01
104200                                                                  90/01/01
104300 SIGNAL-NOT-LOGICAL-EXPRESSION.                                   95/12/23
104400     MOVE "LENOT A LOGICAL EXPRESSION" TO CALCPK-ERROR-RETURN     95/12/23
104500     PERFORM SIGNAL-SYNTAX-ERROR                                  95/12/23
104600     .                                                            95/12/23
104700                                                                  95/12/23
104800 SIGNAL-RANGE-ERROR.                                              95/12/23
104900     MOVE "RERANGE ERROR" TO CALCPK-ERROR-RETURN                  95/12/23
105000     PERFORM SIGNAL-SYNTAX-ERROR                                  95/12/23
105100     .                                                            95/12/23
105200                                                                  95/12/23
105300******************    UNSTACK ALL OPERATORS    *******************90/01/01
105400                                                                  90/01/01
105500 UNSTACK-ALL-OPERATORS.                                           90/01/01
105600     PERFORM UNSTACK-OPERATOR                                     90/01/01
105700       UNTIL STACK-PRIORITY (OPERATOR-PTR) < LOWEST-OPR-PRIORITY  90/01/01
105800     .                                                            90/01/01
105900                                                                  90/01/01
106000*******************    UNSTACK IF LEFT PAR    ********************90/01/01
106100                                                                  90/01/01
106200 UNSTACK-IF-LEFT-PAR.                                             90/01/01
106300     IF STACK-OPERATOR (OPERATOR-PTR) = "("                       90/01/01
106400         SUBTRACT 1 FROM OPERATOR-PTR                             90/01/01
106500     ELSE                                                         90/01/01
106600         MOVE "LPMISSING LEFT PARENTHESIS" TO CALCPK-ERROR-RETURN 95/12/23
106700         PERFORM SIGNAL-PARENTHESIS-MISSING                       90/01/01
106800     .                                                            90/01/01
106900                                                                  90/01/01
107000 SIGNAL-PARENTHESIS-MISSING.                                      90/01/01
107100     PERFORM SIGNAL-SYNTAX-ERROR                                  90/01/01
107200     PERFORM SET-ERROR-POSN-AT-END                                90/01/01
107300     .                                                            90/01/01
107400                                                                  90/01/01
107500 SET-ERROR-POSN-AT-END.                                           90/01/01
107600     IF CALCPK-EXPRESSION = SPACES                                90/01/01
107700         MOVE 1 TO CALCPK-ERROR-POSN                              90/01/01
107800     ELSE                                                         90/01/01
107900         PERFORM FIND-LAST-INPUT-CHAR                             90/01/01
108000           VARYING EXPR-INDEX FROM INPUT-SIZE BY -1               95/12/23
108100             UNTIL EXPR-CHAR (EXPR-INDEX) > SPACE                 90/01/01
108200                                                                  90/01/01
108300         MOVE EXPR-INDEX TO CALCPK-ERROR-POSN                     90/01/01
108400     .                                                            90/01/01
108500                                                                  90/01/01
108600 FIND-LAST-INPUT-CHAR.                                            90/01/01
108700     EXIT                                                         90/01/01
108800     .                                                            90/01/01
108900                                                                  90/01/01
109000*******************    UNSTACK IF END MARK    ********************90/01/01
109100                                                                  90/01/01
109200 UNSTACK-IF-END-MARK.                                             90/01/01
109300     IF STACK-OPERATOR (OPERATOR-PTR) = END-MARK-TOKEN            90/01/01
109400         PERFORM UNSTACK-OPERATOR                                 90/01/01
109500     ELSE                                                         90/01/01
109600         PERFORM SIGNAL-END-MARK-EXPECTED                         90/01/01
109700     .                                                            90/01/01
109800                                                                  90/01/01
109900 SIGNAL-END-MARK-EXPECTED.                                        90/01/01
110000     MOVE "RPMISSING RIGHT PARENTHESIS" TO CALCPK-ERROR-RETURN    95/12/23
110100     PERFORM SIGNAL-PARENTHESIS-MISSING                           90/01/01
110200     .                                                            90/01/01
110300                                                                  90/01/01
110400*******************    SIGNAL INVALID TOKEN    *******************90/01/01
110500                                                                  90/01/01
110600 SIGNAL-INVALID-TOKEN.                                            90/01/01
110700     MOVE "ITTOKEN INVALID HERE" TO CALCPK-ERROR-RETURN           95/12/23
110800     MOVE "SYNTAX ERROR" TO PROGRAM-FEEDBACK                      95/12/23
110900     MOVE TOKEN-POSITION TO CALCPK-ERROR-POSN                     95/12/23
111000     .                                                            90/01/01
111100                                                                  90/01/01
111200*******************    SIGNAL TOKEN MISSING    *******************90/01/01
111300                                                                  90/01/01
111400 SIGNAL-TOKEN-MISSING.                                            90/01/01
111500     MOVE "MTUNEXPECTED END OF EXPRESSION" TO CALCPK-ERROR-RETURN 95/12/23
111600     PERFORM SIGNAL-SYNTAX-ERROR                                  90/01/01
111700     PERFORM SET-ERROR-POSN-AT-END                                90/01/01
111800     .                                                            90/01/01
111900                                                                  90/01/01
112000*******************    TERMINATE THE PROGRAM    ******************90/01/01
112100                                                                  90/01/01
112200 TERMINATE-THE-PROGRAM.                                           90/01/01
112300     MOVE PARAMETER-LIST  TO PROGRAM-LINKAGE                      90/01/01
112400     MOVE TERMINATE-EVENT TO THE-NEXT-EVENT                       90/01/01
112500     .                                                            90/01/01