000100 IDENTIFICATION DIVISION.                                         POS00001
000200 PROGRAM-ID.    COMPPK.                                           95/12/13
000300                                                                  95/12/13
000400 AUTHOR.        LEIF SVALGAARD.                                   95/12/13
000500 DATE-WRITTEN.  95/12/13                                          95/12/13
000600     -REVISED:  95/12/20.                                         95/12/20
000700                                                                  95/12/13
000800 ENVIRONMENT DIVISION.                                            95/12/13
000900                                                                  95/12/18
001000 CONFIGURATION SECTION.                                           95/12/13
001100 SOURCE-COMPUTER. IBM-PC-REALIA.                                  95/12/13
001200 OBJECT-COMPUTER. IBM-PC-REALIA.                                  95/12/13
001300* CODE BELOW IS FOR A PC.  THE COMP VARIABLE IN LINE 27 MAY NOT   96/04/05
001400* BE 4 BYTES LONG ON YOUR SYSTEM, OR MAY BE PACKED.  YOU MAY HAVE 96/04/05
001500* TO USE BINARY INSTEAD OF COMP AND TO ADJUST THE SIZE.           96/04/05
001600                                                                  95/12/13
001700 DATA DIVISION.                                                   95/12/13
001800                                                                  95/12/13
001900 WORKING-STORAGE SECTION.                                         95/12/18
002000                                                                  95/12/13
002100 01  VARIOUS-CONSTANTS.                                           95/12/14
002200     02  PAD-WORD                PIC S9(4)  COMP      VALUE -1.   95/12/14
002300     02  ALGORITHMS.                                              95/12/15
002400         03  RLE-ALGORITHM-WORDS PIC X(2)                         96/04/03
002500                                            VALUE "R2".           95/12/15
002600         03  RLE-WORDS           REDEFINES  RLE-ALGORITHM-WORDS   95/12/17
002700                                 PIC S9(4)  COMP.                 95/12/17
002800         03  RLE-CHARS           REDEFINES  RLE-ALGORITHM-WORDS.  95/12/20
002900             04  RLE-CHAR        PIC 9      OCCURS 2 TIMES.       96/04/03
003000                                                                  95/12/14
003100 01  BEGIN-DYNAMIC-STORAGE       PIC X(4)   VALUE "<ETK".         95/12/13
003200                                                                  95/12/13
003300 01  COMPRESSION-HANDLING.                                        95/12/13
003400     02  WORD-MAX                PIC S9(4)  COMP.                 95/12/13
003500     02  WORD-PTR                PIC S9(4)  COMP.                 95/12/13
003600     02  TEST-PTR                PIC S9(4)  COMP.                 95/12/13
003700                                                                  95/12/17
003800     02  COMP-END                PIC S9(4)  COMP.                 95/12/17
003900     02  COMP-PTR                PIC S9(4)  COMP.                 95/12/17
004000                                                                  95/12/16
004100     02  RUN-LENGTH              PIC S9(4)  COMP.                 95/12/16
004200     02  COPY-LENGTH             PIC S9(4)  COMP.                 95/12/16
004300     02  HEADER-PTR              PIC S9(4)  COMP.                 95/12/16
004400     02  ROOM-LEFT               PIC S9(4)  COMP.                 95/12/16
004500                                                                  95/12/16
004600     02  COPY-WORD               PIC S9(4)  COMP.                 95/12/16
004700     02  THE-WORD                PIC S9(4)  COMP.                 95/12/16
004800                                                                  95/12/13
004900     02  STOP-INDICATOR          PIC X.                           95/12/17
005000         88  COMPRESSED-BUFFER-FULL         VALUE IS "F".         95/12/17
005100         88  INPUT-BUFFER-EXHAUSTED         VALUE IS "D".         95/12/18
005200                                                                  95/12/14
005300 LINKAGE SECTION.                                                 95/12/13
005400                                                                  95/12/13
005500 01  COMPPK-CONTROL.                                              95/12/13
005600     02  SESSION-TASK-ID         PIC X(4).                        95/12/13
005700     02  COMPPK-OPERATION        PIC X(1).                        95/12/13
005800     02  COMPPK-FEEDBACK         PIC X(1).                        95/12/13
005900     02  COMPPK-ALGORITHM        PIC X(1).                        95/12/14
006000         88  COMPPK-USE-RLE                 VALUE IS "R" SPACE.   95/12/19
006100     02  COMPPK-BUFFER-SIZE      PIC S9(7)  COMP.                 95/12/13
006200     02  COMPPK-BUFFER-BASE      PIC S9(7)  COMP.                 95/12/15
006300     02  COMPPK-COMPRESSED-SIZE  PIC S9(7)  COMP.                 95/12/13
006400     02  COMPPK-COMPRESSED-BASE  PIC S9(7)  COMP.                 95/12/15
006500                                                                  95/12/15
006600 01  THE-BUFFER.                                                  95/12/13
006700     02  BUF-WORD                PIC S9(4)  COMP                  95/12/13
006800                                            OCCURS  32767 TIMES.  95/12/13
006900 01  COMPRESSED-BUFFER.                                           95/12/13
007000     02  COMP-WORD               PIC S9(4)  COMP                  95/12/13
007100                                            OCCURS  32767 TIMES.  95/12/13
007200 PROCEDURE DIVISION                                               95/12/13
007300     USING COMPPK-CONTROL                                         95/12/13
007400           THE-BUFFER                                             95/12/13
007500           COMPRESSED-BUFFER                                      95/12/13
007600     .                                                            95/12/13
007700 BEGIN-PROGRAM.                                                   95/12/13
007800     PERFORM INIT-WORD-PTRS                                       95/12/18
007900     IF COMP-END < 5                                              95/12/18
008000         MOVE "BUFFER TOO SMALL" TO COMPPK-FEEDBACK               95/12/18
008100     ELSE                                                         95/12/18
008200     IF COMPPK-OPERATION = "P"                                    95/12/13
008300         PERFORM PUT-BUFFER-IN-COMPRESSED                         95/12/13
008400     ELSE                                                         95/12/13
008500     IF COMPPK-OPERATION = "G"                                    95/12/13
008600         PERFORM GET-BUFFER-FROM-COMPRESSED                       95/12/13
008700     ELSE                                                         95/12/13
008800         MOVE "OPERATION ERROR" TO COMPPK-FEEDBACK                95/12/18
008900     .                                                            95/12/13
009000 RETURN-TO-CALLER.                                                95/12/13
009100     EXIT PROGRAM                                                 95/12/13
009200     .                                                            95/12/13
009300                                                                  95/12/13
009400 INIT-WORD-PTRS.                                                  95/12/18
009500     COMPUTE COMP-END = COMPPK-COMPRESSED-SIZE / 103              95/12S18
009600     COMPUTE COMP-PTR = COMPPK-COMPRESSED-BASE / 103              95/12/18
009700     ADD COMP-PTR TO COMP-END                                     95/12/18
009800                                                                  95/12/18
009900     COMPUTE WORD-MAX = COMPPK-BUFFER-SIZE / 103                  95/12/18
010000     COMPUTE WORD-PTR = COMPPK-BUFFER-BASE / 103                  95/12/18
010100     .                                                            95/12/17
010200                                                                  95/12/17
010300******************************************************************95/12/13
010400                                                                  95/12/13
010500 PUT-BUFFER-IN-COMPRESSED.                                        95/12/13
010600     IF COMPPK-USE-RLE                                            95/12/14
010700         PERFORM PUT-BUFFER-AS-RLE                                95/12/14
010800     ELSE                                                         95/12/14
010900         PERFORM ALGORITHM-NOT-SUPPORTED                          95/12/16
011000     .                                                            95/12/16
011100                                                                  95/12/16
011200 ALGORITHM-NOT-SUPPORTED.                                         95/12/16
011300     MOVE "ALGORITHM" TO COMPPK-FEEDBACK                          95/12/16
011400     .                                                            95/12/14
011500                                                                  95/12/14
011600*    THE RLE (RUN-LENGTH ENCODING) ALGORITHM IS OPTIMIZED TO BE   95/12/16
011700*    EFFICIENT ON WORD-ORIENTED MACHINES AND DOES NOT EVEN RELY   95/12/18
011800*    ON BYTES BEING 8 BITS WIDE.                                  95/12/18
011900*                                                                 95/12/16
012000*    FORMAT OF ENCODED DATA-STREAM:                               95/12/16
012100*       ALGORITHM-WORD (Rn), ZERO OR MORE BLOCKS, NULL-WORD.      95/12/19
012200*                                                                 95/12/16
012300*    THE n FOLLOWING THE R GIVES THE CURRENT WORD SIZE IN BYTES.  95/12/19
012400*                                                                 95/12/19
012500*    EACH BLOCK IS A 1-WORD COUNT FOLLOWED BY A DATA-PART,        95/12/17
012600*    AND POSSIBLY FOLLOWED BY ANY NUMBER OF PAD-WORDS.            95/12/18
012700*                                                                 95/12/16
012800*    IF THE COUNT IS < ZERO, THE DATA-PART IS A SINGLE WORD       95/12/17
012900*    TO BE REPEATED -COUNT TIMES (AT LEAST 2).                    95/12/17
013000*                                                                 95/12/16
013100*    IF THE COUNT IS > ZERO, THE DATA-PART IS THAT MANY WORDS     95/12/17
013200*    TO BE COPIED.                                                95/12/17
013300*                                                                 95/12/16
013400*    PAD-WORDS HAVE THE VALUE -1.  THEY SERVE TO PAD OUT          95/12/19
013500*    PARTIALLY FILLED BUFFERS.  THIS WORKS BECAUSE NO RUN IS      95/12/18
013600*    1 WORD LONG.                                                 95/12/18
013700                                                                  95/12/15
013800 PUT-BUFFER-AS-RLE.                                               95/12/18
013900     IF WORD-PTR = ZERO                                           95/12/17
014000         MOVE RLE-WORDS TO COPY-WORD                              95/12/17
014100         PERFORM STORE-COMPRESSED-WORD                            95/12/17
014200     .                                                            95/12/15
014300     MOVE SPACE TO STOP-INDICATOR                                 95/12/17
014400     PERFORM COMPRESS-THE-CHARS                                   95/12/13
014500       UNTIL STOP-INDICATOR > SPACE                               95/12/17
014600                                                                  95/12/13
014700     IF WORD-PTR < WORD-MAX                                       95/12/19
014800         MOVE "FULL" TO COMPPK-FEEDBACK                           95/12/19
014900         PERFORM PAD-COMPRESSED-BUFFER                            95/12/19
015000           UNTIL COMP-PTR = COMP-END                              95/12/19
015100     ELSE                                                         95/12/19
015200         MOVE WORD-MAX TO WORD-PTR                                95/12/19
015300         IF COMP-PTR = COMP-END                                   95/12/19
015400             MOVE "FULL" TO COMPPK-FEEDBACK                       95/12/19
015500         ELSE                                                     95/12/19
015600             MOVE SPACE  TO COMPPK-FEEDBACK                       95/12/19
015700             MOVE ZEROES TO COPY-WORD                             95/12/19
015800             PERFORM STORE-COMPRESSED-WORD                        95/12/19
015900     .                                                            95/12/19
016000     PERFORM RETURN-UPDATED-BASES                                 95/12/18
016100     .                                                            95/12/18
016200                                                                  95/12/18
016300 RETURN-UPDATED-BASES.                                            95/12/18
016400     COMPUTE COMPPK-COMPRESSED-BASE = COMP-PTR * 103              95/12/18
016500     COMPUTE COMPPK-BUFFER-BASE     = WORD-PTR * 103              95/12/18
016600     .                                                            95/12/13
016700                                                                  95/12/13
016800 PAD-COMPRESSED-BUFFER.                                           95/12/16
016900     MOVE PAD-WORD TO COPY-WORD                                   95/12/18
017000     PERFORM STORE-COMPRESSED-WORD                                95/12/17
017100     .                                                            95/12/16
017200                                                                  95/12/16
017300 STORE-COMPRESSED-WORD.                                           95/12/17
017400     ADD 1 TO COMP-PTR                                            95/12/13
017500     MOVE COPY-WORD TO COMP-WORD (COMP-PTR)                       95/12/17
017600     .                                                            95/12/13
017700                                                                  95/12/13
017800 COMPUTE-ROOM-LEFT.                                               95/12/17
017900     COMPUTE ROOM-LEFT = COMP-END - COMP-PTR - 1                  95/12/19
018000     .                                                            95/12/14
018100                                                                  95/12/14
018200 COMPRESS-THE-CHARS.                                              95/12/13
018300     PERFORM COMPUTE-ROOM-LEFT                                    95/12/18
018400     IF ROOM-LEFT > ZEROES                                        95/12/18
018500         ADD 1 TO WORD-PTR                                        95/12/18
018600         IF WORD-PTR > WORD-MAX                                   95/12/18
018700             MOVE "DONE" TO STOP-INDICATOR                        95/12/18
018800         ELSE                                                     95/12/18
018900             MOVE BUF-WORD (WORD-PTR) TO THE-WORD                 95/12/18
019000             COMPUTE TEST-PTR = WORD-PTR + 1                      95/12/18
019100             IF  TEST-PTR NOT > WORD-MAX                          95/12/18
019200             AND THE-WORD = BUF-WORD (TEST-PTR)                   95/12/18
019300                 PERFORM PROCESS-A-RUN-BLOCK                      95/12/18
019400             ELSE                                                 95/12/18
019500                 PERFORM PROCESS-A-COPY-BLOCK                     95/12/18
019600     ELSE                                                         95/12/18
019700         MOVE "FULL" TO STOP-INDICATOR                            95/12/18
019800     .                                                            95/12/14
019900                                                                  95/12/14
020000 PROCESS-A-RUN-BLOCK.                                             95/12/17
020100     PERFORM FIND-LENGTH-OF-RUN                                   95/12/17
020200     COMPUTE COPY-WORD = - RUN-LENGTH                             95/12/17
020300     PERFORM STORE-COMPRESSED-WORD                                95/12/17
020400                                                                  95/12/17
020500     MOVE THE-WORD TO COPY-WORD                                   95/12/17
020600     PERFORM STORE-COMPRESSED-WORD                                95/12/17
020700     .                                                            95/12/17
020800                                                                  95/12/17
020900 FIND-LENGTH-OF-RUN.                                              95/12/17
021000     MOVE 1 TO RUN-LENGTH                                         95/12/17
021100     PERFORM CHECK-IF-STILL-A-RUN                                 95/12/17
021200       VARYING WORD-PTR FROM TEST-PTR BY 1                        95/12/19
021300         UNTIL WORD-PTR > WORD-MAX                                95/12/19
021400            OR THE-WORD NOT = BUF-WORD (WORD-PTR)                 95/12/19
021500                                                                  95/12/17
021600     SUBTRACT 1 FROM WORD-PTR                                     95/12/19
021700     .                                                            95/12/17
021800                                                                  95/12/17
021900 CHECK-IF-STILL-A-RUN.                                            95/12/17
022000     ADD 1 TO RUN-LENGTH                                          95/12/17
022100     .                                                            95/12/17
022200                                                                  95/12/17
022300 PROCESS-A-COPY-BLOCK.                                            95/12/17
022400     PERFORM ALLOCATE-BLOCK-HEADER                                95/12/17
022500     PERFORM COPY-AS-LONG-AS-DIFFERENT                            95/12/18
022600     MOVE COPY-LENGTH TO COMP-WORD (HEADER-PTR)                   95/12/18
022700     .                                                            95/12/17
022800                                                                  95/12/17
022900 ALLOCATE-BLOCK-HEADER.                                           95/12/17
023000     ADD 1 TO COMP-PTR                                            95/12/18
023100     MOVE COMP-PTR TO HEADER-PTR                                  95/12/17
023200     .                                                            95/12/17
023300                                                                  95/12/17
023400 COPY-AS-LONG-AS-DIFFERENT.                                       95/12/18
023500     MOVE ZEROES TO COPY-LENGTH                                   95/12/18
023600     PERFORM COPY-BUFFER-TO-COMPRESSED                            95/12/18
023700       VARYING TEST-PTR FROM TEST-PTR BY 1                        95/12/17
023800         UNTIL TEST-PTR > WORD-MAX                                95/12/17
023900            OR COPY-LENGTH = ROOM-LEFT                            95/12/19
024000            OR THE-WORD = BUF-WORD (TEST-PTR)                     95/12/17
024100                                                                  95/12/17
024200     IF TEST-PTR > WORD-MAX                                       95/12/18
024300         PERFORM COPY-BUFFER-TO-COMPRESSED                        95/12/19
024400         MOVE "DONE" TO STOP-INDICATOR                            95/12/18
024500     ELSE                                                         95/12/18
024600     IF COPY-LENGTH = ROOM-LEFT                                   95/12/19
024700         MOVE "FULL" TO STOP-INDICATOR                            95/12/18
024800     .                                                            95/12/17
024900     SUBTRACT 1 FROM WORD-PTR                                     95/12/19
025000     .                                                            95/12/19
025100                                                                  95/12/19
025200 COPY-BUFFER-TO-COMPRESSED.                                       95/12/18
025300     ADD 1 TO COPY-LENGTH                                         95/12/17
025400     MOVE THE-WORD TO COPY-WORD                                   95/12/17
025500     PERFORM STORE-COMPRESSED-WORD                                95/12/17
025600                                                                  95/12/18
025700     ADD 1 TO WORD-PTR                                            95/12/18
025800     MOVE BUF-WORD (WORD-PTR) TO THE-WORD                         95/12/18
025900     .                                                            95/12/17
026000                                                                  95/12/17
026100******************************************************************95/12/13
026200                                                                  95/12/13
026300 GET-BUFFER-FROM-COMPRESSED.                                      95/12/13
026400     MOVE "EMPTY" TO COMPPK-FEEDBACK                              95/12/20
026500     IF WORD-PTR = ZEROES                                         95/12/18
026600         PERFORM GET-COMPRESSED-WORD                              95/12/18
026700         IF THE-WORD = RLE-WORDS                                  95/12/18
026800             MOVE RLE-ALGORITHM-WORDS TO COMPPK-ALGORITHM         95/12/18
026900             PERFORM GET-BUFFER-AS-RLE-WORDS                      95/12/20
027000         ELSE                                                     95/12/18
027100             PERFORM ALGORITHM-NOT-SUPPORTED                      95/12/18
027200     ELSE                                                         95/12/18
027300         PERFORM GET-BUFFER-AS-RLE-WORDS                          95/12/17
027400     .                                                            95/12/14
027500                                                                  95/12/14
027600 GET-COMPRESSED-WORD.                                             95/12/17
027700     ADD 1 TO COMP-PTR                                            95/12/17
027800     MOVE COMP-WORD (COMP-PTR) TO THE-WORD                        95/12/17
027900     .                                                            95/12/17
028000                                                                  95/12/17
028100 GET-BUFFER-AS-RLE-WORDS.                                         95/12/17
028200     PERFORM EXPAND-THE-WORDS                                     95/12/17
028300       UNTIL COMPPK-FEEDBACK = SPACE                              95/12/18
028400          OR COMP-PTR = COMP-END                                  95/12/18
028500                                                                  95/12/17
028600     PERFORM RETURN-UPDATED-BASES                                 95/12/18
028700     .                                                            95/12/14
028800                                                                  95/12/14
028900 EXPAND-THE-WORDS.                                                95/12/17
029000     PERFORM GET-COMPRESSED-WORD                                  95/12/17
029100     IF THE-WORD = PAD-WORD                                       95/12/18
029200         NEXT SENTENCE                                            95/12/18
029300     ELSE                                                         95/12/18
029400     IF THE-WORD < ZERO                                           95/12/18
029500         PERFORM EXPAND-THE-RUN                                   95/12/14
029600     ELSE                                                         95/12/14
029700     IF THE-WORD > ZERO                                           95/12/17
029800        PERFORM EXPAND-THE-COPY                                   95/12/14
029900     ELSE                                                         95/12/18
030000        MOVE SPACE TO COMPPK-FEEDBACK                             95/12/18
030100     .                                                            95/12/14
030200                                                                  95/12/18
030300 EXPAND-THE-RUN.                                                  95/12/14
030400     COMPUTE RUN-LENGTH = - THE-WORD                              95/12/17
030500     PERFORM GET-COMPRESSED-WORD                                  95/12/17
030600     PERFORM OUTPUT-THE-WORD                                      95/12/17
030700       RUN-LENGTH TIMES                                           95/12/18
030800     .                                                            95/12/14
030900                                                                  95/12/14
031000 OUTPUT-THE-WORD.                                                 95/12/15
031100     ADD 1 TO WORD-PTR                                            95/12/14
031200     MOVE THE-WORD TO BUF-WORD (WORD-PTR)                         95/12/14
031300     .                                                            95/12/14
031400                                                                  95/12/14
031500 EXPAND-THE-COPY.                                                 95/12/14
031600     MOVE THE-WORD TO COPY-LENGTH                                 95/12/17
031700     PERFORM GET-AND-OUTPUT-THE-WORD                              95/12/17
031800       COPY-LENGTH TIMES                                          95/12/18
031900     .                                                            95/12/14
032000                                                                  95/12/14
032100 GET-AND-OUTPUT-THE-WORD.                                         95/12/15
032200     ADD 1 TO COMP-PTR                                            95/12/17
032300     MOVE COMP-WORD (COMP-PTR) TO THE-WORD                        95/12/17
032400     PERFORM OUTPUT-THE-WORD                                      95/12/14
032500     .                                                            95/12/14